#include <io.h>
#include <stdio.h>
#include <fcntl.h>

int main(int argc, char *argv[]) {
unsigned short data[7];
unsigned long i;
int f;
  printf("Lexicon portable registration\nToysLoss, 2019\n\n");
  if (argc != 2) {
    printf(
      "Usage: lxregist <lexicon.exe>\n\n"
      "You need a clean (NOT registered) version of \"lexicon.exe\" from distributive.\n\n"
    );
    return(0);
  }
  f = open(argv[1], O_RDWR | O_BINARY);
  if (f == -1) {
    printf("Error: can't open input file for read-write.\n\n");
    return(0);
  }
  printf("Searching for registration block...");
  i = 0;
  while (i < 0x100000UL) {
    lseek(f, i + 0x14, SEEK_SET);
    if (read(f, data, sizeof(data)) != sizeof(data)) {
      i = 1;
      break;
    }
    if ((data[4] == 0xD365) && (data[3] == (i >> 4))) {
      data[3] = 0;
      data[5] = 0x6BE5;
      data[6] = 0xA742;
      lseek(f, i + 0x14, SEEK_SET);
      write(f, data, sizeof(data));
      printf("found at: %08lX\nLexicon now fully portable and registered.\n\n", i);
      i = 0;
      break;
    }
    i += 16;
  }
  close(f);
  if (i) {
    printf("not found\nError: not a Lexicon executable or already registered.\n\n");
  }
  return(0);
}
